package Text::Homoglyph {

my %homoglyphs =
    ' ' => "\x00A0\x2000\x2001\x2002\x2003\x2004\x2005\x2006\x2007\x2008\x2009\x200A\x202F\x205F",
    '!' => "\xFF01\x01C3\x2D51\xFE15\xFE57",
    '"' => "\xFF02",
    '#' => "\xFF03\xFE5F",
    '$' => "\xFF04\xFE69",
    '%' => "\xFF05\x066A\x2052\xFE6A",
    '&' => "\xFF06\xFE60",
    "'" => "\xFF07\x02B9\x0374",
    '(' => "\xFF08\xFE59",
    ')' => "\xFF09\xFE5A",
    '*' => "\xFF0A\x22C6\xFE61",
    '+' => "\xFF0B\x16ED\xFE62",
    ',' => "\xFF0C\x02CF\x16E7\x201A",
    '-' => "\xFF0D\x02D7\x2212\x23BC\x2574\xFE63",
    '.' => "\xFF0E\x2024",
    '/' => "\xFF0F\x1735\x2044\x2215\x29F8",
    '0' => "O\x1D67E",
    '1' => "\x1D7E3\x1D7F7\x2960",
    '2' => "\x1D7E4\x1D7F8",
    '3' => "\x1D7E5\x1D7F9\x01B7",
    '4' => "\x1D7E6\x1D7FA\x13CE",
    '5' => "\x1D7E7\x1D7FB\x1BD",
    '6' => "\x1D7E8\x1D7FC\x13EE",
    "7" => "\x1D7E9\x1D7FD",
    "8" => "\x1D7EA\x1D7FE\x9EA",
    '9' => "\x1D7EB\x1D7FF\x13ED",
    ':' => "\xFF1A\x02D0\x02F8\x0589\x1361\x16EC\x205A\x2236\x2806\xFE13\xFE55",
    ';' => "\xFF1B\x037E\xFE14\xFE54",
    '<' => "\xFF1C\x02C2\x2039\x227A\x276E\x2D66\xFE64",
    '=' => "\xFF1D\x2550\x268C\xFE66",
    '>' => "\xFF1E\x02C3\x203A\x227B\x276F\xFE65",
    '?' => "\xFF1F\xFE16\xFE56",
    '@' => "\xFF20\xFE6B",
    'A' => "\x0391\x0410\x13AA",
    'B' => "\x0392\x0412\x13F4\x15F7\x2C82",
    'C' => "\x03F9\x0421\x13DF\x216D\x2CA4",
    'D' => "\x13A0\x15EA\x216E",
    'E' => "\x0395\x0415\x13AC",
    'F' => "\x15B4",
    'G' => "\x050C\x13C0",
    'H' => "\x0397\x041D\x12D8\x13BB\x157C\x2C8E",
    'I' => "\x0399\x0406\x2160",
    'J' => "\x0408\x13AB\x148D",
    'K' => "\x039A\x13E6\x16D5\x212A\x2C94",
    'L' => "\x13DE\x14AA\x216C",
    'M' => "\x039C\x03FA\x041C\x13B7\x216F",
    'N' => "\x039D\x2C9A",
    'O' => "\x039F\x041E\x2C9E",
    'P' => "\x03A1\x0420\x13E2\x2CA2",
    'Q' => "\x051A\x2D55",
    'R' => "\x13A1\x13D2\x1587",
    'S' => "\x0405\x13DA",
    'T' => "\x03A4\x0422\x13A2",
    'U' => "\x1D5B4\x222A\x1D684",
    'V' => "\x13D9\x2164",
    'W' => "\x13B3\x13D4",
    'X' => "\x03A7\x0425\x2169\x2CAC",
    'Y' => "\x03A5\x2CA8",
    'Z' => "\x0396\x13C3",
    '[' => "\xFF3B",
    '\\' => "\xFF3C\x2216\x29F5\x29F9\xFE68",
    ']' => "\xFF3D",
    '^' => "\xFF3E\x02C4\x02C6\x1DBA\x2303",
    '_' => "\xFF3F\x02CD\x268A",
    '`' => "\xFF40\x02CB\x1FEF\x2035",
    'a' => "\x0251\x0430\x1972",
    'b' => "\x15Af\x042C\x1D5BB\x1031C\x1D68B",
    'c' => "\x03F2\x0441\x217D",
    'd' => "\x0501\x217E",
    'e' => "\x0435\x1971",
    'f' => "\x1D5BF\x1D68F",
    'g' => "\x0261",
    'h' => "\x04BB",
    'i' => "\x0456\x2170",
    'j' => "\x03F3\x0458",
    'k' => "\x1D5C4\x1D694",
    'l' => "\x217C",
    'm' => "\x217F",
    'n' => "\x1952",
    'o' => "\x03BF\x043E\x0D20\x2C9F",
    'p' => "\x0440\x2CA3",
    'q' => "\x024B",
    'r' => "\x1D5CB",
    's' => "\x0455",
    't' => "\x1D5CD\x1D69D",
    'u' => "\x1959\x222A",
    'v' => "\x1D20\x2174\x2228\x22C1",
    'w' => "\x1D21",
    'x' => "\x0445\x2179\x2CAD",
    'y' => "\x0443\x1EFF",
    'z' => "\x1D22",
    '{' => "\xFF5B\xFE5B",
    '|' => "\xFF5C\x01C0\x16C1\x239C\x239F\x23A2\x23A5\x23AA\x23AE\xFFE8",
    '}' => "\xFF5D\xFE5C",
    '~' => "\xFF5E\x02DC\x2053\x223C";

sub homoglyphs(Str $string where $string.chars == 1) is export(*) {
    return $string, |%homoglyphs{$string}.comb;
}

}
